# BloqadeKrylov

Krylov-based emulation in Bloqade.

## Installation

<p>
BloqadeKrylov is a &nbsp;
    <a href="https://julialang.org">
        <img src="https://raw.githubusercontent.com/JuliaLang/julia-logo-graphics/master/images/julia.ico" width="16em">
        Julia Language
    </a>
    &nbsp; package. To install BloqadeKrylov,
    please <a href="https://docs.julialang.org/en/v1/manual/getting-started/">open
    Julia's interactive session (known as REPL)</a> and press <kbd>]</kbd> key in the REPL to use the package mode, and then type the following command:
</p>

For stable release:

```julia
pkg> add BloqadeKrylov
```

For current master:

```julia
pkg> add BloqadeKrylov#master
```

using Test
using BloqadeExpr
using YaoArrayRegister
using BloqadeWaveforms
using BloqadeKrylov
using BloqadeLattices
using BloqadeExpr: Hamiltonian
using Yao

@testset "krylov_sinX" begin

    atoms = generate_sites(ChainLattice(), 1, scale = 1)
    wf = Waveform(t->2.2*2π*sin(2π*t), duration = 1.3);
    h = rydberg_h(atoms; Ω = wf)
    reg = zero_state(length(atoms))
    clocks = collect(0:1e-2:1.3)
    prob = KrylovEvolution(reg, clocks, h)
    show(stdout, MIME"text/plain"(), prob)
    #@test_throws ArgumentError KrylovEvolution(reg, [-0.1, 0.1], h)
    emulate!(prob)

    hs = map(clocks[1:end-1]) do t
        return Matrix(h |> attime(t))
    end

    r = zero_state(length(atoms))
    state = statevec(r)
    durations = diff(clocks)
    for (t, h) in zip(durations, hs)
        state = exp(-im * t * h) * state
    end

    @test state ≈ prob.reg.state

    prob = KrylovEvolution(reg, clocks, h)
    for info in prob
        @test info.clock == clocks[info.step]
    end
end

function onenormest_explicit(A, p::Int=1)
    if p <=0
       error("p must be positive") 
    end

    if p == 1
        return opnorm(A,1)
    else
        D = similar(A)
        mul!(D,A,A)
        for i in 3:p
            mul!(D,A,D)
        end
    end

    return opnorm(D,1)
end

"""
    Compute a lower bound of the 1-norm of a matrix to a power of p

    Parameters
    ----------
    A : ndarray or other linear operator
        A linear operator that can be transposed and that can
        produce matrix products.
    p : power of A, optional (default =1)
    t : int, optional
        A positive parameter controlling the tradeoff between
        accuracy versus time and memory usage.
        Larger values take longer and use more memory
        but give more accurate output.
    itmax : int, optional
        Use at most this many iterations.

    Returns
    -------
    est : float
        An underestimate of the 1-norm of the sparse matrix.

    Notes
    -----
    This is algorithm 2.4 of [1].

    In [2] it is described as follows.
    "This algorithm typically requires the evaluation of
    about 4t matrix-vector products and almost invariably
    produces a norm estimate (which is, in fact, a lower
    bound on the norm) correct to within a factor 3."

    .. versionadded:: 0.13.0

    References
    ----------
    .. [1] Nicholas J. Higham and Francoise Tisseur (2000),
           "A Block Algorithm for Matrix 1-Norm Estimation,
           with an Application to 1-Norm Pseudospectra."
           SIAM J. Matrix Anal. Appl. Vol. 21, No. 4, pp. 1185-1201.

    .. [2] Awad H. Al-Mohy and Nicholas J. Higham (2009),
           "A new scaling and squaring algorithm for the matrix exponential."
           SIAM J. Matrix Anal. Appl. Vol. 31, No. 3, pp. 970-989.

    
"""
function onenormest(A, p::Int=1, t::Int=2, itmax::Int=5)
    if size(A,1) != size(A,2)
        error("expect square matrix.")
    end

    ## if t is larger than the order of A, then set it to the order of A-1
    t_in = min(t, size(A,1)-1)
    t_in = t_in == 0 ? 1 : t_in
    
    
    est, nmults, nresamples = _onenormest_impl(A, adjoint(A), p, t_in, itmax)
    
    return est
end



## _mulp! 
## Y = A^p * X
## p must be positive >=1
function _mulp!(Y::AbstractVecOrMat, A, X::AbstractVecOrMat, p::Int)
    
    # allocate tempo space
    w = similar(X)

    mul!(w,A,X)
    copyto!(Y,w)
    for i in 2:p
        mul!(w,A,Y)
        copyto!(Y,w)
    end
    Y
end

"""
    From Higham and Tisseur:
    "Everything in this section remains valid for complex matrices
    provided that sign(A) is redefined as the matrix (aij / |aij|)
    (and sign(0) = 1) transposes are replaced by conjugate transposes."
"""
@inline function _sign_roundup(X::T) where {T <: Number} 
    X == 0 ? T(1) : X / abs(X)
end



## note this does not check the size of A and B, they need to be the same
@inline function _check_vecs_parallel(a::AbstractVector{T}, b::AbstractVector{T}) where {T <: Number} 
    return abs(dot(a,b)) .≈ length(a)
end


@inline function _check_vec_parallel_in_mat(a::AbstractVector{T}, B::AbstractMatrix{T}) where {T <: Number} 
    return any(abs.(adjoint(a) * B) .≈ length(a))
end

## note this does not check the size of A and B. They need to be the same
## size(A)  == (n,t)
## size(B)  == (n,t)
function _check_cols_parallel(A::AbstractMatrix{T}, B::AbstractMatrix{T}) where {T <: Number} 
    n = size(A,1)
    for j in 1:size(A,2)
        if !_check_vec_parallel_in_mat(A[:,j],B)
            return false
        end
    end
    return true
end


function _check_need_resample(i, X::AbstractMatrix{T}, Y::AbstractMatrix{T}) where {T <: Number}
    # i-th col of X need to resample if 
    #    1) its parallel for a previous col of X
    # OR 2) its parallel to a col of Y
    n, t = size(X)
    v = X[:,i]
    for j in 1:i-1
        if _check_vecs_parallel(v,X[:,j])
            return true
        end
    end

    for j in 1:t
        if _check_vecs_parallel(v,Y[:,j])
            return true
        end
    end

    return false

end 

@inline function _resample_col(i::Int, X::AbstractMatrix{T}) where {T <: Number}
    X[:,i] = rand((1.,-1.),size(X,1))
end

"""
    Compute a lower bound of the 1-norm of a sparse matrix, [implementation]

    Parameters
    ----------
    A : AbstractMatrix
        A linear operator that can produce matrix products, must be square matrix with (nxn)
    AT : AbstractMatrix
        The transpose of A.
    p : int, optional (default =1)
        The power of A
    t : int, optional
        A positive parameter controlling the tradeoff between
        accuracy versus time and memory usage.
    itmax : int, optional
        Use at most this many iterations.

    Returns
    -------
    est : float
        An underestimate of the 1-norm of the sparse matrix.
 
    nmults : int, optional
        The number of matrix products that were computed.
    nresamples : int, optional
        The number of times a parallel column was observed,
        necessitating a re-randomization of the column.

    [Note] This is algorithm 2.4.

"""
function _onenormest_impl(A, AT, p::Int=1, t::Int=2, itmax::Int=5) 
    if itmax < 2
        error("itmax must be at least 2")
    end

    if t < 1
        error("must be at least one column, t>=1")
    end

    n = size(A,1)

    if t >= n
        error("t must be less than the order of A: t=$t n=$n")
    end

    T = eltype(A)
    

    nmults::Int = 0
    nresamples::Int = 0

    X = ones(T,n,1)
    if t > 1
        X = hcat(X,rand((1.,-1.),n,t-1))
        ## checking with previous col, to see if resample is needed
        for i in 2:t
            while _check_vecs_parallel(X[:,i],X[:,i-1])
                #need resample i-th column
                X[:,i] = rand((1.,-1.),n)
                nresamples += 1
            end
        end
    end

    # normalize for each column to be unit 1-norm
    X ./= n

    est =0
    est_old = 0
    ind_hist = Vector{Int}(undef,0)
    k::Int = 1
    S = zeros(T,n,t)
    
    ind = nothing
    ind_best = nothing
    
    while true
        
        Y = similar(X)
        _mulp!(Y,A,X,p) # mulp: Y = A^p * X
        

        nmults += 1
        mags = collect( norm(Y[:,j],1) for j in 1:t )
        est, best_j = findmax(mags)
 
        if (est > est_old) || (k==2)
            if k >= 2
                ind_best = ind[best_j]
            end 
            w = Y[:,best_j]
        end

        # (1)
        if (k >= 2) && (est <= est_old)
            est = est_old
            break
        end
        est_old = est
        S_old = S
        if k > itmax
            break
        end

        S = _sign_roundup.(Y)

        #(2)
        if _check_cols_parallel(S, S_old)
            break
        end

        if t > 1
            for i in 1:t
                while _check_need_resample(i,S,S_old)
                    S[:,i] = rand((1.,-1.),n)
                    nresamples += 1
                end 
            end
        end
        S_old = nothing

        #(3), reuse Y: (note Y is the Z)
        _mulp!(Y,AT,S,p) # mulp: Y = A^p * X


        nmults += 1
        Y = abs.(Y)

        h = collect( maximum(Y[j,:]) for j in 1:n )

        Y = nothing

        #(4) 
        if (k >= 2)  
            if(maximum(h) == h[ind_best])       
                break
            end
        end

        ## sort h in descending order, and re-order ind correspondingly.
        ind = reverse(sortperm(h))[1:t+length(ind_hist)]
        
        h = nothing

        if t > 1
            # (5)
            
            seen = collect(elem in ind_hist for elem in ind)
            # break if the most promising t vec have been visited  
            if all(seen[1:t])
                break
            end
            
            ind = vcat(ind[map(!,seen)], ind[seen])
        end

        fill!(X,0)
        for j in 1:t 
            X[ind[j],j] = 1.
        end

        seen = collect(elem in ind_hist for elem in ind[1:t])
        new_ind = (ind[1:t])[map(!,seen)]
        ind_hist = vcat(ind_hist, new_ind)
        k += 1

    end
    
    return est, nmults, nresamples 

end

using Plots
using LaTeXStrings

Nt = 1000
scale = 6.0

f = open("3-by-3.$(Nt)._$(scale)_.ts","r")
ts = convert(Array{Float64,1}, collect(readeach(f,Float64)))
close(f)


f = open("3-by-3.$(Nt)._$(scale)_.exmp","r")
Ns = convert(Array{Int,1}, collect(readeach(f,Int)))
close(f)


f = open("3-by-3.$(Nt)._$(scale)_.exm_mply.ovh","r")
Nnew_ovhd = convert(Array{Int,1}, collect(readeach(f,Int)))
close(f)


f = open("3-by-3.$(Nt)._$(scale)_.exm_mply.impl","r")
Nnew_impl = convert(Array{Int,1}, collect(readeach(f,Int)))
close(f)


Plots.plot(ts, Ns,linestyle=:dash,label="expmv", ylabel = "# of mul!(::SumOfLinop,v)", xlabel=L"$t$")
Plots.plot!(ts, Nnew_ovhd,linestyle=:dash,label="expm_multiply, overhead (s,m)", ylabel = "# of mul!(::SumOfLinop,v)", xlabel=L"$t$")
Plots.plot!(ts, Nnew_impl,linestyle=:dash,label="expm_multiply, impl", ylabel = "# of mul!(::SumOfLinop,v)", xlabel=L"$t$")
Plots.plot!(ts, Nnew_impl.+Nnew_ovhd,linestyle=:dash,label="expm_multiply (total = overhead+impl)", ylabel = "# of mul!(::SumOfLinop,v)", xlabel=L"$t$")
Plots.title!("3-by-3, Nt = $Nt, scale = $scale")

savefig("3-by-3.$(Nt)._$(scale)_.png")

# benchmark expmv performance for linear map vs sparse matrix
# conclusion: they have similar performance, lienar map is slightly
# slower

using Test
using BloqadeKrylov
using BloqadeExpr
using BloqadeExpr: Hamiltonian
using BenchmarkTools

function benchmark(n)
    atom = [(i,) for i in 1:n]
    h = rydberg_h(atom, Ω = 0.5, C = 109.23)
    H = Hamiltonian(Float64, h)

    M = sum(zip(H.fs, H.ts)) do (f, t)
        return f(0.1) * t
    end

    st = rand(ComplexF64, 1 << n)
    w = zeros(ComplexF64, 1 << n)

    new = @benchmark BloqadeKrylov.expmv!($w, 0.1im, $(H(0.1)), $st)
    old = @benchmark BloqadeKrylov.expmv!($w, 0.1im, $(M), $st)
    return minimum(new).time, minimum(old).time
end

results = map(benchmark, [5, 8, 10, 15])

using Test
using BloqadeExpr
using YaoArrayRegister
using BloqadeWaveforms
using BloqadeKrylov
using BloqadeLattices
using BloqadeExpr: Hamiltonian
using Yao

@testset "emulate" begin
    atoms = generate_sites(ChainLattice(), 4, scale = 3.2)
    clocks = [0.0, 0.5, 0.8, 1.1, 1.5, 1.6]
    wf = piecewise_constant(clocks = clocks, values = [0.0, 2.1, 2.1, 1.5, 0.0])
    h = rydberg_h(atoms; Ω = wf)
    reg = zero_state(length(atoms))
    prob = KrylovEvolution(reg, clocks, h)
    show(stdout, MIME"text/plain"(), prob)
    @test_throws ArgumentError KrylovEvolution(reg, [-0.1, 0.1], h)
    emulate!(prob)

    hs = map(clocks[1:end-1]) do t
        return Matrix(h |> attime(t))
    end

    r = zero_state(length(atoms))
    state = statevec(r)
    durations = diff(clocks)
    for (t, h) in zip(durations, hs)
        state = exp(-im * t * h) * state
    end

    @test state ≈ prob.reg.state

    prob = KrylovEvolution(reg, clocks, h)
    for info in prob
        @test info.clock == clocks[info.step]
    end
end

"""
    struct KrylovOptions

Krylov evolution options.
"""
@option struct KrylovOptions
    progress::Bool = false
    progress_step::Int = 1
    progress_name::String = "emulating"
    normalize_step::Int = 5
    normalize_finally::Bool = true
    tol::Float64 = 1e-7
    expmv_backend = expmv!
end

## this is the abstract type for all evolvers 
## KrylovEvolution, Magnus4Evolution, CFETEvolution
abstract type Evolver end

## ACFET21Evolution, ACFET42Evolution, ACFET65Evolution
abstract type ADEvolver end ## adaptive 

# These are common parts shared by all the evolvers
Base.length(prob::Evolver) = length(prob.durations) + 1
#Base.length(prob::ADEvolver) = nothing

function Base.iterate(prob::Evolver)
    info = (; step = 1, reg = prob.reg, clock = prob.start_clock, duration = zero(prob.start_clock))
    return info, (2, prob.start_clock)
end
#function Base.iterate(prob::ADEvolver)
#    info = (; step = 1, reg = prob.reg, clock = prob.start_clock, duration = zero(prob.start_clock))
#    return info, (2, prob.start_clock)
#end

Base.@propagate_inbounds function Base.iterate(prob::Evolver, (step, clock))
    step > length(prob) && return

    duration = prob.durations[step-1]
    emulate_step!(prob, step, clock, duration)

    info = (; step, reg = prob.reg, clock = clock + duration, duration)
    return info, (step + 1, clock + duration)
end

Base.@propagate_inbounds function Base.iterate(prob::ADEvolver, (step, clock))
    clock >= prob.end_clock && return

    duration = prob.step_size
    emulate_step!(prob, step, clock, duration)

    info = (; step, reg = prob.reg, clock = clock + duration, duration)
    return info, (step + 1, clock + duration)
end

## driver function, user entry point
function BloqadeExpr.emulate!(prob::Evolver)
    niterations = length(prob)
    @inbounds if prob.options.progress
        ProgressLogging.progress() do id
            for info in prob
                if prob.options.progress && mod(info.step, prob.options.progress_step) == 0
                    @info prob.options.progress_name progress = info.step / niterations _id = id
                end
            end
        end
    else
        for info in prob
        end
    end
    return prob
end

tab(indent) = " "^indent

function Base.show(io::IO, mime::MIME"text/plain", prob::Evolver)
    indent = get(io, :indent, 0)
    if typeof(prob) <: CFETEvolution
        println(io, tab(indent), "CFETEvolution", "<",Base.typename(typeof(prob.alg_table)).wrapper, ">:")
    else
        println(io, tab(indent), Base.typename(typeof(prob)).wrapper, ":")
    end
    # state info
    print_state_info(io, prob)
    println(io)

    # clocks
    println(io, tab(indent + 2), "clocks")
    println(io, tab(indent + 4), "start:", prob.start_clock, "μs")
    println(io, tab(indent + 4), " last:", prob.start_clock + sum(prob.durations), "μs")
    println(io)

    # equation info
    show(IOContext(io, :indent => indent + 2), mime, prob.hamiltonian)
    println(io)
    println(io)

    println(io, tab(indent + 2), "Options:")
    for name in fieldnames(KrylovOptions)
        println(io, tab(indent + 4), name, "=", repr(getfield(prob.options, name)))
    end
end

function print_state_info(io::IO, prob::Evolver)
    indent = get(io, :indent, 0)
    println(io, tab(indent + 2), "register info:")
    print(io, tab(indent + 4), "type: ")
    printstyled(io, typeof(prob.reg); color = :green)
    println(io)

    print(io, tab(indent + 4), "storage size: ")
    printstyled(io, Base.format_bytes(storage_size(prob.reg)); color = :yellow)
    return println(io)
end


function uniquetol_list(itr::Array{T,1},tol=1e-6) where {T<:Complex}
    preal = sortperm(real(itr))     # buffer for permutation idxs of reals
    dreal = diff(real(itr[preal]))  # buffer for differences of reals

    pimag = Array{Int}(size(preal))     # buffer for permutation idxs of imags
    dimag = Array{Float64}(size(dreal)) # buffer for differences of imags

    out = [ ];
    pri1=1;
    for pri2 = 1:length(preal)
        # look for tol-wide gap in reals
        if pri2==length(preal) || dreal[pri2] > tol
            pridxs = preal[pri1:pri2]
            sortperm!( pimag[1:length(pridxs)], imag(itr[pridxs]) )
            dimag[1:(length(pridxs)-1)] = diff(imag(itr[preal[pridxs]]))

            pii1=1;
            for pii2 = 1:length(pridxs)
                if pii2==length(pridxs) || dimag[pii2] > tol
                    push!(out, Array{T,1}(itr[pridxs[pii1:pii2]]))
                    pii1=pii2+1;
                end # imag tol check
            end # pii2, tol-large gap in imags

            pri1=pri2+1;
        end # real tol check
    end # pri2, tol-large gap in reals
    return out
end

# https://github.com/JuliaLang/julia/pull/41045
@inline function LinearAlgebra.__normalize!(a::AbstractArray, nrm::Real)
    # The largest positive floating point number whose inverse is less than infinity
    δ = inv(prevfloat(typemax(nrm)))

    if nrm ≥ δ # Safe to multiply with inverse
        invnrm = inv(nrm)
        rmul!(a, invnrm)

    else # scale elements to avoid overflow
        εδ = eps(one(nrm))/δ
        rmul!(a, εδ)
        rmul!(a, inv(nrm*εδ))
    end

    a
end

"""
    struct ACFETEvolution
        ACFETEvolution(reg::AbstractRegister, start_clock, end_clock, h, algo; step_size = 1e-7, kw...)

Create a `ACFETEvolution` object that describes a time evolution
using commutation-free Magnus method with s exponentials with adaptive size
[1] https://arxiv.org/pdf/1102.5071.pdf (eq.58-61) 
[2] SAIM: M2AN 53 (2019) 197–218 A posteriori error estimation for Magnus-type integrators W. Auzinger et.al.

# Arguments

- `reg`: a register, should be a subtype of `AbstractRegister`.
- `start_clock`: the start clock of time evolution.
- `end_clock`: the end clock of time evolution. 
- `h`: a hamiltonian expression.
- `algo`: the algorithm (different orders to use), should be a subtype of `CFETTables`. default is `CFET2_1`

# Keyword Arguments

- `step_size`: intial step size, default is `1e-7`.
- `progress`: show progress bar, default is `false`.
- `progress_name`: progress bar name, default is `"emulating"`.
- `normalize_step`: normalize the state every `normalize_step`.
- `normalize_finally`: wether normalize the state in the end of evolution, default is `true`.
- `tol`: tolerance of the exponential time propogator evaluation method, default is `1e-7`
- `expmv_backend`: the backend for evaluate exponential time propogator, default is `expmv!` (other option: `expm_multiply!`).

# Examples

The following is the simplest way of using `ACFETEvolution`
via [`emulate!`](@ref). For more advanced usage, please refer
to documentation page [Emulation](@ref emulation).

```jldoctest
julia> using Bloqade

julia> r = zero_state(5)
ArrayReg{2, ComplexF64, Array...}
    active qudits: 5/5
    nlevel: 2

julia> atoms = [(i, ) for i in 1:5]
5-element Vector{Tuple{Int64}}:
 (1,)
 (2,)
 (3,)
 (4,)
 (5,)

julia> h = rydberg_h(atoms; Ω=sin)
nqubits: 5
+
├─ [+] ∑ 5.42e6/|x_i-x_j|^6 n_i n_j
└─ [+] Ω(t) ⋅ ∑ σ^x_i


julia> prob = ACFETEvolution(r, 0.0, 0.1, h, CFET2_1());

julia> emulate!(prob); # run the emulation
```
"""
mutable struct ACFETEvolution{Reg<:AbstractRegister,T<:Real,H<:Hamiltonian,ALGTBL<:CFETTables} <: ADEvolver
    reg::Reg
    start_clock::T
    end_clock::T
    step_size::T # this store the current step_size
    hamiltonian::H
    options::KrylovOptions
    alg_table::ALGTBL

    function ACFETEvolution{Reg,T,H,ALGTBL}(reg, start_clock, end_clock, step_size,hamiltonian, options, algo) where {Reg,T,H,ALGTBL}
        start_clock ≥ 0 || throw(ArgumentError("start clock must not be negative"))
        end_clock ≥ 0 || throw(ArgumentError("end clock must not be negative"))

        end_clock ≥ start_clock || throw(ArgumentError("end clock must be larger than start clock"))
        step_size ≤ end_clock-start_clock || throw(ArgumentError("initial step size cannot be larger than the whole evolution time"))
        return new{Reg,T,H,ALGTBL}(reg, start_clock, end_clock, step_size, hamiltonian, options, algo)
    end
end

"""
    ACFETEvolution(reg, start_clock, end_clock, hamiltonian, options)

Create a `ACFETEvolution` object.

# Arguments

- `reg`: a register object.
- `start_clock`: start clock of the evolution.
- `end_clock`: end clock of the evolution.
- `hamiltonian`: low-level hamiltonian object of type [`Hamiltonian`](@ref).
- `options`: options of the evolution in type [`KrylovOptions`](@ref).
"""
function ACFETEvolution(reg, start_clock, end_clock, step_size,hamiltonian, options, algo)
    return ACFETEvolution{typeof(reg),typeof(start_clock),typeof(hamiltonian),typeof(algo)}(
        reg,
        start_clock,
        end_clock,
        step_size,
        hamiltonian,
        options,
        algo,
    )
end

function Adapt.adapt_structure(to, x::ACFETEvolution)
    return ACFETEvolution(adapt(to, x.reg), x.start_clock, x.end_clock, x.step_size, adapt(to, x.hamiltonian), x.options, x.alg_table)
end

function ACFETEvolution(reg::AbstractRegister, start_clock, end_clock , h, algo::CFETTables = CFET2_1(); step_size=1e-7, kw...)
    all(≥(0), clocks) || throw(ArgumentError("clocks must not be negative"))
    options = from_kwargs(KrylovOptions; kw...)
    P = real(eltype(statevec(reg)))
    T = isreal(h) ? P : Complex{P}
    
    return ACFETEvolution(reg, start_clock, end_clock, step_size, Hamiltonian(T, h, space(reg)), options, algo)
end

## given Hamiltonian, current time `t` and duration `dt`, plus a CFETTable, 
# output generator Ω at certain ETstep (exponential time propogator) 
## t + xs[i]dt
function __construct_Ω(h::Hamiltonian, t::Real, dt::Real, Tbl::CFETTables, ETStep::Int)
    
    gs = Tbl.Gs[ETStep]
    xs = Tbl.xs 
    
    fs = gs[1]*h(t + xs[1]*dt).fvals

    for i in 2:length(gs)      
        fs += gs[i]*h(t + xs[i]*dt).fvals
    end

    return SumOfLinop{LinearAlgebra.Hermitian}(fs, h.ts)
end

function __construct_dΩ(h::Hamiltonian, t::Real, dt::Real, Tbl::CFETTables, ETStep::Int)
    
    gs = Tbl.Gs[ETStep]
    xs = Tbl.xs 
    
    fs = gs[1]*xs[1]*derivative.(h.fs,t + xs[1]*dt)

    for i in 2:length(gs)      
        fs += gs[i]*xs[i]*derivative.(h.fs,t + xs[i]*dt)
    end

    return SumOfLinop{LinearAlgebra.Hermitian}(fs, h.ts)
end

@inline function scale_factor(αmin, αmax, α, ϵ, tol, p)
    return min(αmax, max(αmin, α*(tol/ϵ)^(1/(p+1))))
end

## here, since generic algo for defect is unclear, we specialize it for each support types:
function emulate_step!(prob::ACFETEvolution{<:Any,<:Any,<:Any,ALGTBL<:CFET2_1}, step::Int, clock::Real, tol::Real)
    state = statevec(prob.reg)
    Ham = prob.hamiltonian

    duration = prob.step_size # get duration 

    #construct Ωi:
    Ω1 = -im*__construct_Ω(Ham, clock, duration, prob.alg_table, 1)
    dΩ1 = -im*__construct_dΩ(Ham, clock, duration, prob.alg_table, 1)


    # perform evolution:
    prob.options.expmv_backend(duration, Ω1, state; prob.options.tol)


    ## calculate defect operator
    Bv = similar(state)
    dBv = similar(state)
    tmp = similar(state)

    mul!(Bv, Ω1, state)
    mul!(dBv, dΩ1, state)
    dest = Bv .+ duration*dBv

    mul!(tmp, Ω1, dBv)
    mul!(dBv, dΩ1, Bv)
    Bv = tmp

    ## [B,B']v
    dest .+= (duration^2/2)*(Bv - dBv)

    ## -A(t+τ)v
    mul!(tmp, Ham(clock+duration), state)
    dest .-= tmp

    ϵ = norm(dest)

    ## calculate and update next step size:
    prob.step_size = duration*scale_factor(0.25, 4.0 , 0.9, ϵ, tol, p)


    # do we need this normalization? 
    if mod(step, prob.options.normalize_step) == 0
        normalize!(prob.reg)
    end

    if prob.options.normalize_finally && step == length(prob.durations)
        normalize!(prob.reg)
    end
    
    return prob
end

function emulate_step!(prob::ACFETEvolution, step::Int, clock::Real, duration::Real)
    error("unsupported CFET algo for adaptive step-size")
end

abstract type CFETTables end

"""
    struct CFETEvolution
        CFETEvolution(reg::AbstractRegister, clocks, h, algo; kw...)

Create a `CFETEvolution` object that describes a time evolution
using commutation-free Magnus method with s exponentials.
https://arxiv.org/pdf/1102.5071.pdf (eq.58-61) 


# Arguments

- `reg`: a register, should be a subtype of `AbstractRegister`.
- `clocks`: the clocks of this time evolution at each step.
- `h`: a hamiltonian expression.
- `algo`: the algorithm (different orders to use), should be a subtype of `CFETTables`. default is `CFET4_2`

# Keyword Arguments

- `progress`: show progress bar, default is `false`.
- `progress_name`: progress bar name, default is `"emulating"`.
- `normalize_step`: normalize the state every `normalize_step`.
- `normalize_finally`: wether normalize the state in the end of evolution, default is `true`.
- `tol`: tolerance of the exponential time propogator evaluation method, default is `1e-7`
- `expmv_backend`: the backend for evaluate exponential time propogator, default is `expmv!` (other option: `expm_multiply!`).

# Examples

The following is the simplest way of using `CFETEvolution`
via [`emulate!`](@ref). For more advanced usage, please refer
to documentation page [Emulation](@ref emulation).

```jldoctest
julia> using Bloqade

julia> r = zero_state(5)
ArrayReg{2, ComplexF64, Array...}
    active qudits: 5/5
    nlevel: 2

julia> atoms = [(i, ) for i in 1:5]
5-element Vector{Tuple{Int64}}:
 (1,)
 (2,)
 (3,)
 (4,)
 (5,)

julia> h = rydberg_h(atoms; Ω=sin)
nqubits: 5
+
├─ [+] ∑ 5.42e6/|x_i-x_j|^6 n_i n_j
└─ [+] Ω(t) ⋅ ∑ σ^x_i


julia> prob = CFETEvolution(r, 0.0:1e-2:0.1, h, CFET4_2());

julia> emulate!(prob); # run the emulation
```
"""
struct CFETEvolution{Reg<:AbstractRegister,T<:Real,H<:Hamiltonian,ALGTBL<:CFETTables} <: Evolver
    reg::Reg
    start_clock::T
    durations::Vector{T}
    hamiltonian::H
    options::KrylovOptions
    alg_table::ALGTBL

    function CFETEvolution{Reg,T,H,ALGTBL}(reg, start_clock, durations, hamiltonian, options, algo) where {Reg,T,H,ALGTBL}
        start_clock ≥ 0 || throw(ArgumentError("start clock must not be negative"))
        all(≥(0), durations) || throw(ArgumentError("durations must not be negative"))
        return new{Reg,T,H,ALGTBL}(reg, start_clock, durations, hamiltonian, options, algo)
    end
end

"""
    CFETEvolution(reg, start_clock, durations, hamiltonian, options)

Create a `CFETEvolution` object.

# Arguments

- `reg`: a register object.
- `start_clock`: start clock of the evolution.
- `durations`: list of durations at each time step.
- `hamiltonian`: low-level hamiltonian object of type [`Hamiltonian`](@ref).
- `options`: options of the evolution in type [`KrylovOptions`](@ref).
"""
function CFETEvolution(reg, start_clock, durations, hamiltonian, options, algo)
    return CFETEvolution{typeof(reg),typeof(start_clock),typeof(hamiltonian),typeof(algo)}(
        reg,
        start_clock,
        durations,
        hamiltonian,
        options,
        algo,
    )
end

function Adapt.adapt_structure(to, x::CFETEvolution)
    return CFETEvolution(adapt(to, x.reg), x.start_clock, x.durations, adapt(to, x.hamiltonian), x.options, x.alg_table)
end

function CFETEvolution(reg::AbstractRegister, clocks, h, algo::CFETTables = CFET4_2(); kw...)
    all(≥(0), clocks) || throw(ArgumentError("clocks must not be negative"))
    options = from_kwargs(KrylovOptions; kw...)
    P = real(eltype(statevec(reg)))
    T = isreal(h) ? P : Complex{P}
    start_clock, durations = first(clocks), diff(clocks)
    
    return CFETEvolution(reg, start_clock, durations, Hamiltonian(T, h, space(reg)), options, algo)
end

## given Hamiltonian, current time `t` and duration `dt`, plus a CFETTable, 
# output generator Ω at certain ETstep (exponential time propogator) 
## t + xs[i]dt
function __construct_Ω(h::Hamiltonian, t::Real, dt::Real, Tbl::CFETTables, ETStep::Int)
    
    gs = Tbl.Gs[ETStep]
    xs = Tbl.xs 
    
    fs = gs[1]*h(t + xs[1]*dt).fvals

    for i in 2:length(gs)      
        fs += gs[i]*h(t + xs[i]*dt).fvals
    end


    return SumOfLinop{LinearAlgebra.Hermitian}(fs, h.ts)

end


function emulate_step!(prob::CFETEvolution, step::Int, clock::Real, duration::Real)

    state = statevec(prob.reg)
    Ham = prob.hamiltonian
    
    ## each exponential-time prop. 
    for i in 1:length(prob.alg_table.Gs)
        
        #construct Ωi:
        Ωi = __construct_Ω(Ham, clock, duration, prob.alg_table, i)
        
        # perform evolution:
        prob.options.expmv_backend(-duration, im*Ωi, state; prob.options.tol)

    end

    # do we need this normalization? 
    if mod(step, prob.options.normalize_step) == 0
        normalize!(prob.reg)
    end

    if prob.options.normalize_finally && step == length(prob.durations)
        normalize!(prob.reg)
    end
    
    return prob

end

##==========================================================
#  Following are helper functions for calculating cfet tables
##==========================================================

function Lagendre(n::Int, x::Real)
    if n == 0
        return 1
    elseif n == 1
        return 2*x-1
    else
        return ((2n-1)*(2x-1)*Lagendre(n-1,x) - (n-1)*Lagendre(n-2,x))/n
    end
end

## arXiv:1102.5071 eq.(60)
#  Given Fs table, and Gaussian quadrature points xs and weights weights,
#  Generate Gs table with size (# of exponential time steps) x (# of quadrature points)
#  1. Fs have to be size (# of exponential time steps) x (# of order N/2+1)
#  2. (generally second axes of Fs it can be up to N but (R2) providing high order term can be ignore)

## TODO: calculate Lagendre on the fly
function __get_Gs(Fs::Vector{Vector{Float64}}, xs::Vector{Float64}, ws::Vector{Float64})
    
    Gs = Vector{Vector{Float64}}([zeros(length(xs)) for i in 1:length(Fs)])
    Nm = length(Fs[1])
    FL = length(Fs)

    ## Gs is filled in reverse order opposed from the definition becase eval of expm is in reverse order (right to left)
    for i in 1:FL
        for m in 1:length(xs)
            Gs[FL+1-i][m] = ws[m]*sum(Fs[i][n]*(2n-1)*Lagendre(n-1,xs[m]) for n in 1:Nm)
        end
    end
    return Gs

end

include("tools.jl")

## define problem-1
## 1) real time
prob_name = "chain_sin_cos"


nsites = 10
dt = 1e-3
tspan = 0:dt:1.0
atoms = generate_sites(ChainLattice(), nsites, scale = 6)
h = rydberg_h(atoms; Ω = sin, ϕ = cos)

H = BloqadeExpr.Hamiltonian(ComplexF64, h)

# expmv
reg = zero_state(nsites)
nmul_old = testing_expmv!(H, tspan, reg)

# expmv
reg1 = zero_state(nsites)
nmul_overhead, nmul_impl = testing_expm_multiply!(H, tspan, reg1)

#checking
println(statevec(reg) ≈ statevec(reg1))


open("$prob_name.$nsite","w") do f
    write(f,es)
end

using Bloqade
using BloqadeKrylov
using Plots

function H1_SinCos(T, Nt)
    atoms = generate_sites(ChainLattice(), 1, scale = 1)
    wf = Waveform(t->2.2*2π*sin(2π*t), duration = T);
    wf2 = Waveform(t->2.2*2π*cos(2π*t), duration = T);
    h = rydberg_h(atoms; Ω = wf, Δ = wf2)   
    atoms, h
end

function get_exact(T,testing_hamilt)
    NT = 7000
    atoms, h = testing_hamilt(T,NT)
    dt = T/NT
    clocks = collect(0:dt:T)
    odereg = zero_state(length(atoms))
    ODEprob = SchrodingerProblem(odereg,T,h)
    emulate!(ODEprob)
    return ODEprob
end

function krylov(T,NT,testing_hamilt)
    atoms, h = testing_hamilt(T,NT)
    dt = T/NT
    clocks = collect(0:dt:T)
    reg = zero_state(length(atoms))
    prob = KrylovEvolution(reg, clocks, h)
    emulate!(prob)
    return prob
end

function magnus42(T,NT,testing_hamilt)
    atoms, h = testing_hamilt(T,NT)
    dt = T/NT
    clocks = collect(0:dt:T)
    reg = zero_state(length(atoms))
    prob = CFETEvolution(reg, clocks, h, CFET4_2())
    emulate!(prob)
    return prob
end

function magnus65(T,NT,testing_hamilt)
    atoms, h = testing_hamilt(T,NT)
    dt = T/NT
    clocks = collect(0:dt:T)
    reg = zero_state(length(atoms))
    prob = CFETEvolution(reg, clocks, h, CFET6_5())
    emulate!(prob)
    return prob
end

function magnus811(T,NT,testing_hamilt)
    atoms, h = testing_hamilt(T,NT)
    dt = T/NT
    clocks = collect(0:dt:T)
    reg = zero_state(length(atoms))
    prob = CFETEvolution(reg, clocks, h, CFET8_11())
    emulate!(prob)
    return prob
end

Ns = [2,4,8,16,32,64,128,256,512,1024,2048]
open("Ns","w") do f
    write(f,Ns)
end
Tfull = 1.3
# get exact
res_exact = get_exact(Tfull,H1_SinCos)


## krylov
es = Vector{Float64}(undef,0)
for n in Ns
    res = krylov(Tfull,n,H1_SinCos)
    ## calculate differences:
    e = norm(res_exact.reg.state - res.reg.state)
    push!(es,e)
end
println(es)
open("es_kry","w") do f
    write(f,es)
end

## magnus 42
es = Vector{Float64}(undef,0)
for n in Ns
    res = magnus42(Tfull,n,H1_SinCos)
    ## calculate differences:
    e = norm(res_exact.reg.state - res.reg.state)
    push!(es,e)
end
println(es)
open("es_m42","w") do f
    write(f,es)
end

## magnus 65
es = Vector{Float64}(undef,0)
for n in Ns
    res = magnus65(Tfull,n,H1_SinCos)
    ## calculate differences:
    e = norm(res_exact.reg.state - res.reg.state)
    push!(es,e)
end
println(es)
open("es_m65","w") do f
    write(f,es)
end

## magnus 811
es = Vector{Float64}(undef,0)
for n in Ns
    res = magnus811(Tfull,n,H1_SinCos)
    ## calculate differences:
    e = norm(res_exact.reg.state - res.reg.state)
    push!(es,e)
end
println(es)
open("es_m811","w") do f
    write(f,es)
end

using Bloqade
using BloqadeKrylov
using Plots
using LaTeXStrings

f = open("Ns","r")
Ns = convert(Array{Float64,1}, collect(readeach(f,Int64)))
close(f)

f = open("es_kry","r")
reskry = convert(Array{Float64,1}, collect(readeach(f,Float64)))
close(f)

f = open("es_m42","r")
res42 = convert(Array{Float64,1}, collect(readeach(f,Float64)))
close(f)

f = open("es_m65","r")
res65 = convert(Array{Float64,1}, collect(readeach(f,Float64)))
close(f)

f = open("es_m811","r")
res811 = convert(Array{Float64,1}, collect(readeach(f,Float64)))
close(f)

Plots.plot(Ns, reskry, marker=".",label="krylov", xaxis=:log, yaxis=:log, xlabel = L"$N_T$", ylabel=L"$ϵ$")
Plots.plot!(Ns, res42, marker=".",label="magnus42", xaxis=:log, yaxis=:log, xlabel = L"$N_T$", ylabel=L"$ϵ$")
Plots.plot!(Ns, res65, marker=".",label="magnus65", xaxis=:log, yaxis=:log, xlabel = L"$N_T$", ylabel=L"$ϵ$")
Plots.plot!(Ns, res811, marker=".",label="magnus811", xaxis=:log, yaxis=:log, xlabel = L"$N_T$", ylabel=L"$ϵ$")
savefig("SinCos.png")


Plots.plot(Ns, reskry, marker=".",label="krylov", xaxis=:log, yaxis=:log, xlabel = L"$N_T$", ylabel=L"$ϵ$")
Plots.plot!(Ns.*2, res42, marker=".",label="magnus42", xaxis=:log, yaxis=:log, xlabel = L"$N_T \times s (\# of expmv)$", ylabel=L"$ϵ$")
Plots.plot!(Ns.*5, res65, marker=".",label="magnus65", xaxis=:log, yaxis=:log, xlabel = L"$N_T \times s (\# of expmv) $", ylabel=L"$ϵ$")
Plots.plot!(Ns.*11, res811, marker=".",label="magnus811", xaxis=:log, yaxis=:log, xlabel = L"$N_T \times s (\# of expmv)$", ylabel=L"$ϵ$")
savefig("SinCos_scale.png")

using Test
using BloqadeExpr
using YaoArrayRegister
using BloqadeWaveforms
using BloqadeKrylov
using BloqadeLattices
using BloqadeExpr: Hamiltonian
using Yao

include("exact_sol_sinX.jl")


@testset "cfet65_sinX" begin
    
    atoms = generate_sites(ChainLattice(), 1, scale = 1)
    wf = Waveform(t->2.2*2π*sin(2π*t), duration = 1.3);
    h = rydberg_h(atoms; Ω = wf)

    ## do magnus4
    reg = zero_state(length(atoms))
    clocks = collect(0:1e-3:1.3)
    prob = CFETEvolution(reg, clocks, h, CFET6_5())
    show(stdout, MIME"text/plain"(), prob)
    emulate!(prob)

    @test prob.reg.state ≈ solution(1.3)

    reg = zero_state(length(atoms))
    prob = CFETEvolution(reg, clocks, h, CFET6_5())
    for info in prob
        @test info.reg.state ≈ solution(info.clock)
    end
    
end

using LinearAlgebra

function evolution_operator(t::Float64)
    ϕ = 2.2 * sin(π * t)^2
    U = zeros(ComplexF64, 2,2)
    U[1,1] =  1 / sqrt(2)
    U[2,1] =  1 / sqrt(2)
    U[2,2] =  1 / sqrt(2)
    U[1,2] = -1 / sqrt(2)

    U * diagm(exp.([-im*ϕ, im*ϕ])) * U'
end

function solution(t)
    U = evolution_operator(t)
    return U * [1.0, 0.0]

end

using Test
using BloqadeKrylov
using LinearAlgebra
using SparseArrays
using BloqadeExpr



@testset "internal _mulp!" begin

    A = sprand(10, 10, 0.5)
    st = rand(10)

    G = A
    # testing p:
    for p in 1:5
        tar = similar(st)
        BloqadeKrylov._mulp!(tar, A, st, p)

        src = G*st

        @test tar ≈ src
        G *= A
    end

    
end


@testset "internal  _sign_roundup(X::T)" begin

    a = 3.34
    b = -3.24
    c = 0.0
    d = -0.0
    e = 1+1im
    f = -2+1im


    @test BloqadeKrylov._sign_roundup(a) == 1
    @test BloqadeKrylov._sign_roundup(b) == -1
    @test BloqadeKrylov._sign_roundup(c) == 1
    @test BloqadeKrylov._sign_roundup(d) == 1
    @test BloqadeKrylov._sign_roundup(e) == (1+1im)/√2
    @test BloqadeKrylov._sign_roundup(f) == (-2+1im)/√5
    
end


@testset "internal  _check_cols_parallel (REAL)" begin

    A = randn(10,10)
    A = BloqadeKrylov._sign_roundup.(A)

    @test BloqadeKrylov._check_cols_parallel(A,A) == true


    
end

@testset "internal  _check_cols_parallel (Complex)" begin

    A = randn(ComplexF64, 10,10)
    A = BloqadeKrylov._sign_roundup.(A)


    @test BloqadeKrylov._check_cols_parallel(A,A) == true
    
end



@testset "internal  _check_vecs_parallel (Complex)" begin

    A = randn(ComplexF64, 10,10)
    A = BloqadeKrylov._sign_roundup.(A)

    for i in 1:10
        for j in 1:10
            if i == j
                @test BloqadeKrylov._check_vecs_parallel(A[:,i],A[:,j]) == true
            end
        end
    end


    
end

@testset "onenormest impl" begin

    ## real
    A = [1. 0. 0. ; 5. 8. 2. ; 0 -1 0]
    
    nrm = LinearAlgebra.opnorm(A,1)
    nrmest,_,_ = BloqadeKrylov._onenormest_impl(A, transpose(A), 1)

    @test nrm ≈ nrmest


    A = [1. 0. 0. ; 5. 8. 2. ; 0 -1 0]
    
    nrm = LinearAlgebra.opnorm(A*A,1)
    nrmest,_,_ = BloqadeKrylov._onenormest_impl(A, transpose(A), 2)

    @test nrm ≈ nrmest

    ## complex
    A = [1+1im 2+0.5im 3.; 0. 6.7im -3.2-1im; 3.14 0.7+0.55im 0.29im+3.2]
    
    nrm = LinearAlgebra.opnorm(A,1)

    nrmest, _ , _ = BloqadeKrylov._onenormest_impl(A, adjoint(A), 1)

    @test nrm ≈ nrmest

    A = [1+1im 2+0.5im 3.; 0. 6.7im -3.2-1im; 3.14 0.7+0.55im 0.29im+3.2]
    
    nrm = LinearAlgebra.opnorm(A*A,1)

    nrmest, _ , _ = BloqadeKrylov._onenormest_impl(A, adjoint(A), 2)

    @test nrm ≈ nrmest


end


@testset "onenormest, API" begin

    ## real
    A = [1. 0. 0. ; 5. 8. 2. ; 0 -1 0]
    
    nrm = LinearAlgebra.opnorm(A,1)
    nrmest = BloqadeKrylov.onenormest(A, 1)

    @test nrm ≈ nrmest


    A = [1. 0. 0. ; 5. 8. 2. ; 0 -1 0]
    
    nrm = LinearAlgebra.opnorm(A*A,1)
    nrmest = BloqadeKrylov.onenormest(A, 2)

    @test nrm ≈ nrmest

    ## complex
    A = [1+1im 2+0.5im 3.; 0. 6.7im -3.2-1im; 3.14 0.7+0.55im 0.29im+3.2]
    
    nrm = LinearAlgebra.opnorm(A,1)

    nrmest = BloqadeKrylov.onenormest(A, 1)

    @test nrm ≈ nrmest

    A = [1+1im 2+0.5im 3.; 0. 6.7im -3.2-1im; 3.14 0.7+0.55im 0.29im+3.2]
    
    nrm = LinearAlgebra.opnorm(A*A,1)

    nrmest = BloqadeKrylov.onenormest(A, 2)

    @test nrm ≈ nrmest
    

end

# Ref[1] arxiv:1102.5071 eq.(59)
# notation: 
#   
#   Ωi = ∑_(m=1) Gs[i,m] Ham(t + xs[m]δt)   
#
#   Gs: number of exponential time propogator (stored in the order from right to left)
#        Gs has size (# of exponential time propogator,length(xs))
#   xs: location of the gaussian lagendre quadrature (which we choosen to be N/2, but generally can be larger)
#       

# CFET with 2nd order with 1 exponentials:
# (2nd order midpoint rule)
struct CFET2_1 <: CFETTables
    xs::Vector{Float64}
    Gs::Vector{Vector{Float64}}
    function CFET2_1()
        xs =  [0.5]
        Gs = [[1.0]]
        return new(xs,Gs)
    end
end

# CFET with 4th order with 2 exponentials:
struct CFET4_2 <: CFETTables
    xs::Vector{Float64}
    Gs::Vector{Vector{Float64}}
    function CFET4_2()
        xs =  [1/2 - √3/6, 1/2 + √3/6]
        Gs = [[1/4 + √3/6, 1/4 - √3/6], 
              [1/4 - √3/6, 1/4 + √3/6]]
        return new(xs,Gs)
    end
end

# CFET with 4th order with 2 exponentials:
#= tested! auto matic generate way.
struct CFET42Gen <: CFETTables
    xs::Vector{Float64}
    Gs::Vector{Vector{Float64}}
    function CFET42Gen()
        xs, ws = GaussQuadrature.legendre(2) 
        xs .+= 1.0
        xs ./= 2.0
        ws ./= 2.0

        Fs = [[1/2, 1/3 ],
              [1/2, -1/3]]
        
        Gs = __get_Gs(Fs,xs,ws) 
        return new(xs,Gs)
    end
end
=#

# CFET with 6th order with 5 exponentials:
# (unoptimized coefficients)
struct CFET6_5  <: CFETTables
    xs::Vector{Float64}
    Gs::Vector{Vector{Float64}}
    function CFET6_5()
        
        xs, ws = GaussQuadrature.legendre(5) # this can change, but generally choose s = m is ok
        xs .+= 1.0
        xs ./= 2.0
        ws ./= 2.0 

        # Fs is the coefficients matching convention from Ref[1]
        # the second index runs from 1 ~ N/2 
        Fs = [[0.16                  , 0.14587456942714338561, 0.11762370828143015682], 
              [0.38752405202531186588, 0.15089113704380764664, -0.12805075909013044594]]
        
        
        push!(Fs,[1-2*Fs[2][1]-2*Fs[1][1], 0 , -2*Fs[2][3]-2*Fs[1][3]])
        
        # make the rest base on T-symm condition (R1)
        push!(Fs,[ (n+1)%2==0 ? Fs[2][n] : -Fs[2][n] for n in 1:length(Fs[2])])
        push!(Fs,[ (n+1)%2==0 ? Fs[1][n] : -Fs[1][n] for n in 1:length(Fs[1])])

        return new(xs,__get_Gs(Fs, xs, ws))
    end
end


# CFET with 8th order with 11 exponentials:
# (unoptimized coefficients)
struct CFET8_11  <: CFETTables
    xs::Vector{Float64}
    Gs::Vector{Vector{Float64}}
    function CFET8_11()
        
        xs, ws = GaussQuadrature.legendre(4) # this can change, but generally choose s = m is ok
        xs .+= 1.0
        xs ./= 2.0
        ws ./= 2.0 

        # Fs is the coefficients matching convention from Ref[1]
        # the second index runs from 1 ~ N/2 
        f11 = 0.169715531043933180094151;  f12 = 0.152866146944615909929839
        f13 = 0.119167378745981369601216;  f14 = 0.068619226448029559107538
        f21 = 0.379420807516005431504230;  f22 = 0.148839980923180990943008
        f23 = -0.115880829186628075021088; f24 = -0.188555246668412628269760
        f31 = 0.469459306644050573017994;  f32 = -0.379844237839363505173921
        f33 = 0.022898814729462898505141;  f34 = 0.571855043580130805495594
        f41 = -0.448225927391070886302766; f42 = 0.362889857410989942809900
        f43 = -0.022565582830528472333301; f44 = -0.544507517141613383517695
        f51 = -0.293924473106317605373923; f52 = -0.026255628265819381983204
        f53 = 0.096761509131620390100068;  f54 = 0.000018330145571671744069
        f61 = 0.447109510586798614120629;  f63 = -0.200762581179816221704073

        Fs = [[f11, f12, f13, f14], 
              [f21, f22, f23, f24],
              [f31, f32, f33, f34],
              [f41, f42, f43, f44],
              [f51, f52, f53, f54],
              [f61,   0, f63,   0]] # the zeros here are requred by reveral of T-symm

        
        # make the rest base on T-symm condition (R1)
        for p in 5:-1:1
            push!(Fs,[ (n+1)%2==0 ? Fs[p][n] : -Fs[p][n] for n in 1:length(Fs[p])])
        end 


        return new(xs,__get_Gs(Fs, xs, ws))
    end
end

using Test
using BloqadeExpr
using BloqadeKrylov
using Yao

@testset "The Levine-Pichler gate" begin
    nsites = 2
    V = 1e3
    Ω_r = 1.0
    τ = 4.29268/Ω_r
    Δ_r = 0.377371*Ω_r
    ϕ_r = 3.90242  # sign flipped
    atoms = [(0.0, 0.0), (0.0, (862690*2pi/V)^(1/6))]

    reg = zero_state(nsites; nlevel = 3)
    h1 = rydberg_h_3(atoms; Ω_hf = 1)
    prob1 = KrylovEvolution(reg, 0:1e-4:1/2*pi, h1)
    emulate!(prob1)
    goal1 = [0.5; -0.5im; 0; -0.5im; -0.5; 0; 0; 0; 0]  # ((|0> - i|1>)/√2)^{⊗2}
    @test isapprox(state(reg), goal1; atol = 1e-3)

    h2 = rydberg_h_3(atoms; Ω_r = Ω_r, Δ_r = Δ_r)
    prob2 = KrylovEvolution(reg, 0:1e-4:τ, h2)
    emulate!(prob2)
    goal2 = exp(-im*τ*Matrix(h2)) * goal1
    @test isapprox(state(reg), goal2; atol = 1e-3)

    h3 = rydberg_h_3(atoms; Ω_r = Ω_r, Δ_r = Δ_r, ϕ_r = ϕ_r)
    BloqadeExpr.mat(h3)
    prob3 = KrylovEvolution(reg, 0:1e-4:τ, h3)
    emulate!(prob3)
    goal3 = exp(-im*τ*Matrix(h3)) * goal2
    @test isapprox(state(reg), goal3; atol = 1e-3)
end

@testset "|11> -> -i/√2*(|1r> + |r1>)" begin
    nsites = 2
    V = 1e5
    atoms = [(0.0, 0.0), (0.0, (862690*2pi/V)^(1/6))]
    reg = product_state(dit"11;3")
    h = rydberg_h_3(atoms; Ω_r = 1)

    goal = exp(-im*pi/sqrt(2)*Matrix(h)) * state(reg)
    prob = KrylovEvolution(reg, 0:1e-2:pi/sqrt(2), h)
    emulate!(prob)
    @test isapprox(state(reg), goal; atol = 1e-2)
end

using Test
using ForwardDiff
using BloqadeExpr
using YaoArrayRegister
using BloqadeKrylov


ForwardDiff.derivative(2.0) do x
    T = 0.1
    dT = T / 10
    reg = zero_state(Complex{typeof(x)}, 5)
    atoms = [(6.7 * i,) for i in 1:5]
    h = rydberg_h(atoms; Ω = x, Δ = t -> -5 * cos(π * t / T))
    prob = KrylovEvolution(reg, 0:dT:T, h)
    emulate!(prob)
    return abs2(statevec(reg)[1])
end

using ExponentialUtilities

@testset "Gradients of atom positions" begin
    nsites = 5
    scale = 5.0
    function loss_atoms(ps)
        atoms = [[ps[i, 1], ps[i, 2]] for i = 1:nsites]
        reg = zero_state(Complex{typeof(ps[1, 1])}, nsites)
        rh = rydberg_h(atoms; Ω = 1)
        prob = KrylovEvolution(reg, 0:1e-2:1, rh)
        emulate!(prob)
        return abs2(statevec(reg)[1])
    end
    ps = rand(nsites, 2) * scale
    ForwardDiff.gradient(loss_atoms, ps)
end

@testset "ForwardDiff broken" begin
    ForwardDiff.derivative(2.0) do x
        reg = zero_state(Complex{typeof(x)}, 5)
        atoms = [(6*i,) for i in 1:5]
        h = rydberg_h(atoms; Ω = sin, Δ = x)
        prob = KrylovEvolution(reg, 0:1e-3:0.02, h)
        emulate!(prob)
        return abs2(statevec(reg)[1])
    end
    
    # # failing function, doesn't seem to 
    # @test isnan(ForwardDiff.derivative(2.0) do x
    #     h = fill(zero(typeof(x)), (2, 2))
    #     F = ExponentialUtilities.exponential!(im * h, ExpMethodGeneric())
    #     return sum(F)
    # end)
end

using Test
using BloqadeKrylov
using SparseArrays

@testset "expmv" begin
    A = rand(10, 10)
    st = rand(10)
    @test BloqadeKrylov.expmv(-0.1im, A, st) ≈ exp(-0.1im * A) * st

    A = sprand(ComplexF64, 10, 10, 0.8)
    st = rand(ComplexF64, 10)
    @test BloqadeKrylov.expmv(-0.1im, A, st) ≈ exp(-0.1im * Matrix(A)) * st
end

## TODO this does not explicity constrain the type yet, A&B have to be SparseMatrixCSR or LuxurySparse
function commutator(A, B)
    return A*B - B*A
end 

"""
    struct Magnus4Evolution
    Magnus4Evolution(reg::AbstractRegister, clocks, h; kw...)

Create a `Magnus4Evolution` object that describes a time evolution
using Magnus method with 4th order.

# Arguments

- `reg`: a register, should be a subtype of `AbstractRegister`.
- `clocks`: the clocks of this time evolution at each step.
- `h`: a hamiltonian expression.

# Keyword Arguments

- `progress`: show progress bar, default is `false`.
- `progress_name`: progress bar name, default is `"emulating"`.
- `normalize_step`: normalize the state every `normalize_step`.
- `normalize_finally`: wether normalize the state in the end of evolution, default is `true`.
- `tol`: tolerance of the Krylov-expmv evaluation method, default is `1e-7`

# Examples

The following is the simplest way of using `Magnus4Evolution`
via [`emulate!`](@ref). For more advanced usage, please refer
to documentation page [Emulation](@ref emulation).

```jldoctest
julia> using Bloqade

julia> r = zero_state(5)
ArrayReg{2, ComplexF64, Array...}
    active qudits: 5/5
    nlevel: 2

julia> atoms = [(i, ) for i in 1:5]
5-element Vector{Tuple{Int64}}:
 (1,)
 (2,)
 (3,)
 (4,)
 (5,)

julia> h = rydberg_h(atoms; Ω=sin)
nqubits: 5
+
├─ [+] ∑ 5.42e6/|x_i-x_j|^6 n_i n_j
└─ [+] Ω(t) ⋅ ∑ σ^x_i


julia> prob = Magnus4Evolution(r, 0.0:1e-2:0.1, h);

julia> emulate!(prob); # run the emulation
```
"""
struct Magnus4Evolution{Reg<:AbstractRegister,T<:Real,H<:Hamiltonian} <: Evolver
    reg::Reg
    start_clock::T
    durations::Vector{T}
    hamiltonian::H
    options::KrylovOptions

    function Magnus4Evolution{Reg,T,H}(reg, start_clock, durations, hamiltonian, options) where {Reg,T,H}
        start_clock ≥ 0 || throw(ArgumentError("start clock must not be negative"))
        all(≥(0), durations) || throw(ArgumentError("durations must not be negative"))
        return new{Reg,T,H}(reg, start_clock, durations, hamiltonian, options)
    end
end

"""
    Magnus4Evolution(reg, start_clock, durations, hamiltonian, options)

Create a `Magnus4Evolution` object.

# Arguments

- `reg`: a register object.
- `start_clock`: start clock of the evolution.
- `durations`: list of durations at each time step.
- `hamiltonian`: low-level hamiltonian object of type [`Hamiltonian`](@ref).
- `options`: options of the evolution in type [`KrylovOptions`](@ref).
"""
function Magnus4Evolution(reg, start_clock, durations, hamiltonian, options)
    return Magnus4Evolution{typeof(reg),typeof(start_clock),typeof(hamiltonian)}(
        reg,
        start_clock,
        durations,
        hamiltonian,
        options,
    )
end

function Adapt.adapt_structure(to, x::Magnus4Evolution)
    return Magnus4Evolution(adapt(to, x.reg), x.start_clock, x.durations, adapt(to, x.hamiltonian), x.options)
end

function Magnus4Evolution(reg::AbstractRegister, clocks, h; kw...)
    all(≥(0), clocks) || throw(ArgumentError("clocks must not be negative"))
    options = from_kwargs(KrylovOptions; kw...)
    P = real(eltype(statevec(reg)))
    T = isreal(h) ? P : Complex{P}
    start_clock, durations = first(clocks), diff(clocks)
    
    ## checking if it is equal time:
    if length(unique(round.(durations,digits = 14) ) )  != 1
        throw(ArgumentError("durations must be equal (time slice must be equal)"))
    end 

    return Magnus4Evolution(reg, start_clock, durations, Hamiltonian(T, h, space(reg)), options)
end



# simple version
function emulate_step!(prob::Magnus4Evolution, step::Int, clock::Real, duration::Real)
    state = statevec(prob.reg)
    h = prob.hamiltonian
    
    A1 = BloqadeExpr.to_matrix(h(clock + (0.5-√3/6)*duration))
    A2 = BloqadeExpr.to_matrix(h(clock + (0.5+√3/6)*duration)) 
    
    Ω4 = 0.5 * (A1 + A2) - duration*√3/12 * commutator(A1, A2)
    
    prob.options.expmv_backend(-duration, im*Ω4, state; prob.options.tol) 

    # do we need this normalization? 
    
    if mod(step, prob.options.normalize_step) == 0
        normalize!(prob.reg)
    end

    if prob.options.normalize_finally && step == length(prob.durations)
        normalize!(prob.reg)
    end
    
    return prob
end

using Bloqade
using BloqadeKrylov


# create problem Hamiltonian 
r = zero_state(5)
atoms = [(i, ) for i in 1:5]
h = rydberg_h(atoms; Ω=sin)

# * using CFET integrator 
#    algo options (naming convention CFET<N>_<s>)
#      N: order of the magnus expansion. 
#      s: number of exponential-time propogator
#     -> CFET2_1(), CFET4_2(), CFET6_5(), CFET8_11()
prob = CFETEvolution(r, 0.0:1e-2:0.1, h, algo=CFET4_2())

# run the emulation
emulate!(prob)

## look up table for now
# [This table is calculated for Float64 precision 2^-53]
# App. Table A.3
# Computing Matrix Functions
# Higham, Nicholas J. and Al-Mohy, Awad H.
# 2010
struct θ_table
    ms::Vector{Int}
    θs::Vector{Float64}
    max_m::Int
    function θ_table()
        ms = Vector{Int}([1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,
            17,18,19,20,21,22,23,24,25,26,27,28,29,30,
            35,40,45,50,55])
        ts = Vector{Float64}([2.29e-16,
                            2.58e-8,
                            1.39e-5,
                            3.40e-4,
                            2.40e-3,
                            9.07e-3,
                            2.38e-2,
                            5.00e-2,
                            8.96e-2,
                            1.44e-1,
                            2.14e-1,
                            3.00e-1,
                            4.00e-1,
                            5.14e-1,
                            6.41e-1,
                            7.81e-1,
                            9.31e-1,
                            1.09,
                            1.26,
                            1.44,
                            1.62,
                            1.82,
                            2.01,
                            2.22,
                            2.43,
                            2.64,
                            2.86,
                            3.08,
                            3.31,
                            3.54,
                            4.7,
                            6.0,
                            7.2,
                            8.5,
                            9.9])


        return new(ms,ts,55)
    end
end
function get_theta(θ_tbl::θ_table, m::Int)
    if !(m in θ_tbl.ms)
        error("m is not in the table")
    end
    return θ_tbl.θs[indexin(m, θ_tbl.ms)[1]]
end

function get_optimal_sm(t::Real, A::T, m_max::Int=55, ell::Int=2) where {T}
    """
        given an matrix A and t, find the optimal s and m_star for expm_multiply.
        [return] m_star, s, μ, A_1norm, As
        mu is the shifted constant μ
        A_1norm is the 1-norm of A
        As is the shifted A, As = A - mu*I
    """


     # 1) shift the A:
    traceA = LinearAlgebra.tr(A)
    n = size(A,1)
    μ = traceA/size(A,1) 
    
    #As = A - μ*LinearAlgebra.I(n)
    As = BloqadeExpr.add_I(A,-μ)

    #using onenormest to get 1-norm of As
    A_1norm = onenormest(As,1)

    m_star::Int = 1
    s::Int = 1
    if t*A_1norm != 0
        m_star, s = _calc_optimal_sm(As, A_1norm, abs(t), m_max, ell)
    end
    
    return m_star, s, μ, A_1norm, As
end

function expm_multiply(t::Real,
                       A,
                       v::AbstractVector{T};
                       tol = nothing) where {T}
    v_prom = similar(v, promote_type(eltype(A), T, typeof(t)))
    copyto!(v_prom, v)

    out = similar(v_prom)
    expm_multiply!(out, t, A, v_prom; tol)
    return out
end

function expm_multiply!(t::Real,
                        A,
                        v::AbstractVector{T};
                        tol = nothing) where {T}

    w = similar(v)
    expm_multiply!(w, t, A, v; tol)
    copyto!(v,w)
end 

function expm_multiply!(w::AbstractVector{T}, 
                       t::Real,
                       A,
                       v::AbstractVector{T};
                       tol = nothing
                       ) where {T}
    if size(v, 1) != size(A, 2)
        error("dimension mismatch")
    end


    if tol === nothing
        # infer tol base on the size of T
        size_T = sizeof(real(T))
        if size_T == 8
            tol = 2^(-53)
        elseif size_T == 4
            tol = 2^(-24)
        else
            error("Unsupported type T of vec{T} for auto set tol")
        end
    end
    
    # 1) get the optimal s and m_star, and As--shifted A
    # note that here we use abs(t) instead of t so the A_T on onenormest is lazy evaluated.
    m_star, s, μ, A_1norm, As = get_optimal_sm(t,A)


    # 3) here lies the impl call:
    _expm_multiply_impl!(w, t, As, v, μ, s, m_star, tol)
    return w 
end 
                        
# n0 = 1
function _condition_3_13(θ_tbl, tA_1norm, m_max::Int, ell::Int)
    ## compute p_max:
    sqrt_m_max = sqrt(m_max)
    p_low = Int(floor(sqrt_m_max))
    p_high = Int(ceil(sqrt_m_max+1))
    p_max = maximum([p for p in p_low:1:p_high if p*(p-1) <= m_max + 1]) 

    a = 2*ell * p_max * (p_max+3)
    b = get_theta(θ_tbl,m_max) / float(m_max)

    return tA_1norm <= a*b, p_max

end


function calc_d(A,p::Int)
    est = onenormest(A,p)
    return est^(1.0/p)
end 

function _calc_optimal_sm(A, A_1norm, t::Real, m_max::Int=55, ell::Int=2) 

    As = t*A
    tA_1norm = t*A_1norm

    θ_tbl = θ_table()
    if m_max > θ_tbl.max_m
        error("m_max > ",θ_tbl.max_m, " is not supported")
    end

    m_star = nothing
    s_star = nothing

    flag, p_max = _condition_3_13(θ_tbl, tA_1norm, m_max, ell)
    if flag
        for (i, θ) in enumerate(θ_tbl.θs)
            m = θ_tbl.ms[i]
            s = Int(ceil(tA_1norm/θ))
            
            if m_star === nothing
                m_star = m
                s_star = s
            elseif m * s < m_star*s_star
                m_star = m
                s_star = s
            end
        end
    else
        # eq(3.11)
        d = calc_d(As, 2)
        for p in 2:p_max
            # compute d_p+1
            d1 = calc_d(As, p+1)
            αp = max(d,d1)
            d = d1
            for m in p*(p-1):m_max
                if m in θ_tbl.ms
                    s = Int(ceil(αp / get_theta(θ_tbl,m))) #compute_cost_div_m
                    if m_star === nothing
                        m_star = m
                        s_star = s
                    elseif m * s < m_star*s_star
                        m_star = m
                        s_star = s
                    end
                end
            end
        end
        s_star = max(s_star,1)  
    end   
    return m_star, s_star

end


"""
    _expm_multiply_impl!(w::AbstractVector{T}
                         t::Real,
                         As, 
                         v::AbstractVector{T},
                         mu::Real, #shift parameter
                         s::Int,
                         m_star::Int,
                         tol::Real,
                        ) where {T}
    Calculate matrix exponential acting on some vector, ``w = e^{tA}v``,
    using the Krylov subspace approximation.

    [Note] As is a sugeried matrix, i.e. As= A - mu*I

"""
function _expm_multiply_impl!(w::AbstractVector{T},
                             t::Real,
                             As, 
                             v::AbstractVector{T},
                             mu::Number, #shift parameter
                             s::Int,
                             m_star::Int,
                             tol::Real,
                            ) where {T}
    #println(typeof(As))
    F = deepcopy(v)
    vs = deepcopy(v)
    η = exp(t*mu/s)
    for i in 1:s
        c1 = norm(vs,Inf)
        for j in 1:m_star
            coef = t / (s*j)
            mul!(vs, As, coef*vs)
            c2 = norm(vs,Inf)
            F.+=vs
            if c1+c2 <= tol*norm(F,Inf)
                break
            end
            c1 = c2
        end
        F.*=η
        copyto!(vs,F)
    end 
    copy!(w,F)
    return w
end

using Revise
using BloqadeKrylov
using Bloqade
using LinearAlgebra
using BloqadeLattices 


function writeSparseCSC(A,fname)

    open("$fname.size","w") do f
        write(f,A.m)
        write(f,A.n)
    
    end
    
    open("$fname.colptr","w") do f
        write(f,A.colptr)
    end
    open("$fname.rowval","w") do f
        write(f,A.rowval)
    end
    open("$fname.nzval","w") do f
        write(f,A.nzval)
    end

end

## wrapping Hamiltonian with counter that count the number of mul! calls
mutable struct WHam
    h
    counter::Vector{Int}
    function WHam(h, counter= Vector{Int}([0]))
        return new(h,counter)
    end
end

Base.size(M::WHam) = size(M.h)
Base.size(M::WHam,i::Int) = size(M.h,i)
#opnorm(M::WHam) = opnorm(M.h)
LinearAlgebra.opnorm(M::WHam,p=2) = opnorm(M.h,p)
Base.eltype(M::WHam) = eltype(M.h)


function count_mul!(a::AbstractVecOrMat, M::WHam, x::AbstractVecOrMat)
    M.counter[1] += 1
    mul!(a, M.h, x)
end
LinearAlgebra.mul!(a::AbstractVecOrMat,M::WHam,x::AbstractVecOrMat) = count_mul!(a,M,x)
LinearAlgebra.tr(M::WHam) = tr(M.h)
BloqadeExpr.add_I(M::WHam, c::Number) =  WHam(BloqadeExpr.add_I(M.h, c), M.counter)
Base.:*(c::Number, M::WHam) = WHam(c*M.h, M.counter)
LinearAlgebra.adjoint(M::WHam) = WHam(adjoint(M.h), M.counter)
##===================================


# reg inplace modify
function testing_expmv!(H::BloqadeExpr.Hamiltonian, tspan, reg)
    n_mul = Vector{Int}(undef,0)
    for t in tspan
        Ht = WHam(H(t))
    
        BloqadeKrylov.expmv!((dt)*im, Ht, statevec(reg), tol=1.0e-7)
    
        #println(norm(statevec(reg)))
        #println(Ht.counter[1])
        push!(n_mul, Ht.counter[1])
    end
    return n_mul
end

function testing_expm_multiply!(H::BloqadeExpr.Hamiltonian, tspan, reg)
    n_mul_impl = Vector{Int}(undef,0)
    n_mul_sm = Vector{Int}(undef,0)
    print(tspan)
    for t in tspan
        Ht = H(t)
        Ht = WHam(Ht)
    

        #BloqadeKrylov.expm_multiply!((dt)*im, Ht, statevec(reg1))
        #^> unwrap it to get counting for mul from get optimal sm overhead
        ti = (dt)


        m_star, s, μ, A_1norm, As = BloqadeKrylov.get_optimal_sm(ti,im*Ht)
        push!(n_mul_sm, Ht.counter[1])
        Ht.counter[1] = 0

        v = statevec(reg)
        w = similar(v)


        #assuming its ComplexF64
        BloqadeKrylov._expm_multiply_impl!(w, ti, As, v, μ, s, m_star,1.0e-7)



        copyto!(v,w)
        
        
        #println(norm(statevec(reg)))
        #println(Ht.counter[1])
        push!(n_mul_impl, Ht.counter[1])
    end
    return n_mul_sm, n_mul_impl
end

# NOTE: copied from Expokit
# TODO: fully switch to ExponentialUtilities after fixing complex number
function default_anorm(A)
    try
        opnorm(A, Inf)
    catch err
        if err isa MethodError
            @warn "opnorm($(typeof(A)), Inf) is not defined, fall back to using `anorm = 1.0`.
To suppress this warning, please specify the `anorm` keyword manually."
            1.0
        else
            throw(err)
        end
    end
end

"""
    expmv(t, A, vec; [tol], [m], [norm], [anorm])
Calculate matrix exponential acting on some vector, ``w = e^{tA}v``,
using the Krylov subspace approximation.
See R.B. Sidje, ACM Trans. Math. Softw., 24(1):130-156, 1998
and http://www.maths.uq.edu.au/expokit
"""
function expmv(
    t::Number,
    A,
    vec::AbstractVector{T};
    tol::Real = 1e-7,
    m::Int = min(30, size(A, 1)),
    norm = LinearAlgebra.norm,
    anorm = default_anorm(A),
) where {T}
    result = similar(vec, promote_type(eltype(A), T, typeof(t)))
    copyto!(result, vec)
    expmv!(t, A, result; tol = tol, m = m, norm = norm, anorm = anorm)
    return result
end

function expmv!(
    t::Number,
    A,
    vec::AbstractVector{T};
    tol::Real = 1e-7,
    m::Int = min(30, size(A, 1)),
    norm = LinearAlgebra.norm,
    anorm = default_anorm(A),
) where {T}
    expmv!(vec, t, A, vec; tol = tol, m = m, norm = norm, anorm = anorm)
    return vec
end

function unwrap_value(x) # unwrap ForwardDiff.Dual
    return hasfield(typeof(x), :value) ? x.value : x
end

function expmv!(
    w::AbstractVector{T},
    t::Number,
    A,
    vec::AbstractVector{T};
    tol::Real = 1e-7,
    m::Int = min(30, size(A, 1)),
    norm = LinearAlgebra.norm,
    anorm = default_anorm(A),
    expmethod = real(T) <: LinearAlgebra.BlasReal ? ExpMethodHigham2005() : ExpMethodGeneric(),
) where {T}
    if size(vec, 1) != size(A, 2)
        error("dimension mismatch")
    end
    # safety factors
    gamma = 0.9
    delta = 1.2
    btol = 1e-7     # tolerance for "happy-breakdown"
    maxiter = 10    # max number of time-step refinements
    rndoff = anorm * eps()
    # estimate first time-step and round to two significant digits
    beta = norm(vec)
    r = 1 / m
    fact = (((m + 1) / exp(1.0))^(m + 1)) * sqrt(2.0 * pi * (m + 1))
    tau = (1.0 / anorm) * ((fact * tol) / (4.0 * beta * anorm))^r
    tau = round(unwrap_value(tau), sigdigits = 2)
    # storage for Krylov subspace vectors
    vm = Array{typeof(w)}(undef, m + 1)
    for i in 1:m+1
        vm[i] = similar(w)
    end
    hm = zeros(T, m + 2, m + 2)
    tf = abs(t)
    tsgn = sign(t)
    tk = zero(tf)
    copyto!(w, vec)
    p = similar(w)
    mx = m
    while tk < tf
        tau = min(tf - tk, tau)
        # Arnoldi procedure
        # vm[1] = v/beta
        rmul!(copyto!(vm[1], w), 1 / beta)
        mx = m
        for j in 1:m
            # p[:] = A*vm[j]
            mul!(p, A, vm[j])
            for i in 1:j
                hm[i, j] = dot(vm[i], p)
                # p[:] = p - hm[i,j]*vm[i]
                p = axpy!(-hm[i, j], vm[i], p)
            end
            s = norm(p)
            if s < btol # happy-breakdown
                tau = tf - tk
                err_loc = btol
                # F = expm(tsgn*tau*hm[1:j,1:j])
                # F = expm!(scale(tsgn*tau,view(hm,1:j,1:j)))
                L = tsgn * tau * view(hm, 1:j, 1:j)
                F = ExponentialUtilities.exponential!(L, expmethod)
                fill!(w, zero(T))
                for k in 1:j
                    # w[:] = w + beta*vm[k]*F[k,1]
                    w = axpy!(beta * F[k, 1], vm[k], w)
                end
                mx = j
                break
            end
            hm[j+1, j] = s
            # vm[j+1] = p/hm[j+1,j]
            rmul!(copyto!(vm[j+1], p), 1 / hm[j+1, j])
        end
        hm[m+2, m+1] = one(T)
        (mx != m) || (avnorm = norm(mul!(p, A, vm[m+1])))
        # propagate using adaptive step size
        iter = 1
        while (iter < maxiter) && (mx == m)
            # F = expm(tsgn*tau*hm)
            # F = expm!(scale(tsgn*tau,hm))
            F = ExponentialUtilities.exponential!(tsgn * tau * hm, expmethod)
            # local error estimation
            err1 = abs(beta * F[m+1, 1])
            err2 = abs(beta * F[m+2, 1] * avnorm)
            if err1 > 10 * err2# err1 >> err2
                err_loc = err2
                r = 1 / m
            elseif err1 > err2
                err_loc = (err1 * err2) / (err1 - err2)
                r = 1 / m
            else
                err_loc = err1
                r = 1 / (m - 1)
            end
            # time-step sufficient?
            if err_loc <= delta * tau * (tau * tol / err_loc)^r
                fill!(w, zero(T))
                for k in 1:m+1
                    # w[:] = w + beta*vm[k]*F[k,1]
                    w = axpy!(beta * F[k, 1], vm[k], w)
                end
                break
            end
            tau = gamma * tau * (tau * tol / err_loc)^r # estimate new time-step
            tau = round(unwrap_value(tau), sigdigits = 2) # round to 2 signiﬁcant digits
            # to prevent numerical noise
            iter = iter + 1
        end
        if iter == maxiter
            # TODO, here an exception should be thrown, but which?
            error("Number of iterations exceeded $(maxiter). Requested tolerance might be to high.")
        end
        beta = norm(w)
        tk = tk + tau
        tau = gamma * tau * (tau * tol / err_loc)^r # estimate new time-step
        tau = round(unwrap_value(tau), sigdigits = 2) # round to 2 signiﬁcant digits
        # to prevent numerical noise
        err_loc = max(err_loc, rndoff)
        fill!(hm, zero(T))
    end
    return w
end # expmv!

using Test
using BloqadeExpr
using YaoArrayRegister
using BloqadeWaveforms
using BloqadeKrylov
using BloqadeLattices
using BloqadeExpr: Hamiltonian
using Yao

@testset "magnus4_sinX" begin

    atoms = generate_sites(ChainLattice(), 1, scale = 1)
    wf = Waveform(t->2.2*2π*sin(2π*t), duration = 1.3);
    h = rydberg_h(atoms; Ω = wf)

    ## do magnus4
    reg = zero_state(length(atoms))
    clocks = collect(0:1e-3:1.3)
    prob = Magnus4Evolution(reg, clocks, h)
    show(stdout, MIME"text/plain"(), prob)
    #@test_throws ArgumentError KrylovEvolution(reg, [-0.1, 0.1], h)
    emulate!(prob)
    @test prob.reg.state ≈ solution(1.3)

    reg = zero_state(length(atoms))
    prob = Magnus4Evolution(reg, clocks, h)
    for info in prob
        @test info.reg.state ≈ solution(info.clock)
    end
end

include("tools.jl")

## define problem-1
## 1) real time
prob_name = "3-by-3"

function H2_Square(T,ascale)
    nx, ny = 3, 3
    nsites = nx * ny
    atoms = generate_sites(SquareLattice(), nx, ny, scale = ascale)
    
    Ω_max = 2π * 4.3
    Ω = piecewise_linear(clocks = [0.0/T, 0.3/T, 2.6/T, 1.0].*T, values = [0.0, Ω_max, Ω_max, 0]);

    U = 2π * 15.0
    Δ = piecewise_linear(clocks = [0.0/T, 0.3/T, 2.6/T, 1.0].*T, values = [-U, -U, U, U]);

    h = rydberg_h(atoms; Δ, Ω)
    atoms, h
end

nsites = 9

T = 2.9
Nt = 1000
scale = 2.0

atoms, h = H2_Square(T,scale)
dt = T/Nt
tspan = dt:dt:T

H = BloqadeExpr.Hamiltonian(ComplexF64, h)

# expmv
reg = zero_state(nsites)
nmul_old = testing_expmv!(H, tspan, reg)

# expmv
reg1 = zero_state(nsites)
#tspan = dt:dt:2dt
nmul_overhead, nmul_impl = testing_expm_multiply!(H, tspan, reg1)


#checking
print(statevec(reg1)[1:10])
print(statevec(reg)[1:10])
println(statevec(reg) .≈ statevec(reg1))



open("$prob_name.$Nt._$(scale)_.exmp","w") do f
    write(f,nmul_old)
end

open("$prob_name.$Nt._$(scale)_.exm_mply.ovh","w") do f
    write(f,nmul_overhead)
end
open("$prob_name.$Nt._$(scale)_.exm_mply.impl","w") do f
    write(f,nmul_impl)
end

open("$prob_name.$Nt._$(scale)_.ts","w") do f
    write(f,collect(tspan))
end

using Test
using BloqadeKrylov
using SparseArrays
using BloqadeLattices
using BloqadeWaveforms
using BloqadeExpr: Hamiltonian 
using BloqadeExpr
using Yao

@testset "expm_multiply_impl Real, dense A" begin

    A = rand(10, 10)
    st = rand(10)


    vold = BloqadeKrylov.expmv(1, A, st)


    vnew = similar(st)
    st_before = deepcopy(st)
    BloqadeKrylov._expm_multiply_impl!(vnew, 1, A, st, 0, 1, 40, 2^-53)

    # checking st is not modefied
    @test st_before == st
    
    #  checking results against expmv
    @test vnew ≈ vold
end

@testset "expm_multiply_impl complex, sparse A" begin

    A = sprand(ComplexF64,10, 10, 0.6)
    st = rand(ComplexF64,10)


    vold = BloqadeKrylov.expmv(1, A, st)


    vnew = similar(st)
    st_before = deepcopy(st)
    BloqadeKrylov._expm_multiply_impl!(vnew, 1, A, st, 0, 1, 40, 2^-53)

    # checking st is not modefied
    @test st_before == st
    
    #  checking results against expmv
    @test vnew ≈ vold

end


@testset "expm_multiply Real, dense A" begin

    A = rand(10, 10)
    st = rand(10)


    vold = BloqadeKrylov.expmv(2.55, A, st)


    vnew = similar(st)
    st_before = deepcopy(st)
    BloqadeKrylov.expm_multiply!(vnew, 2.55, A, st)

    # checking st is not modefied
    @test st_before == st
    
    #  checking results against expmv
    @test vnew ≈ vold

end

@testset "expm_multiply complex, sparse A" begin

    A = sprand(ComplexF64,10, 10, 0.6)
    st = rand(ComplexF64,10)


    vold = BloqadeKrylov.expmv(2.55, A, st)


    vnew = similar(st)
    st_before = deepcopy(st)
    BloqadeKrylov.expm_multiply!(vnew, 2.55, A, st)

    # checking st is not modefied
    @test st_before == st
    
    #  checking results against expmv
    @test vnew ≈ vold

end

@testset "expm_multiply, Rydberg" begin

    atoms = generate_sites(ChainLattice(), 4, scale = 6.1)
    clocks = [0.0, 0.5, 0.8, 1.1, 1.5, 1.6]
    wf = piecewise_constant(clocks = clocks, values = [0.0, 2.1, 2.1, 1.5, 0.0])
    h = rydberg_h(atoms; Ω = wf)

    Ham = Hamiltonian(Float64, h)
    #print(Ham)
    Ht = Ham(0.6)
    reg = zero_state(length(atoms))
    state = statevec(reg)


    vold = BloqadeKrylov.expmv(0.05, to_matrix(Ht), state)

    println("main")
    println(vold)
    vs = similar(state)
    BloqadeKrylov.expm_multiply!(vs, 0.05, to_matrix(Ht), state)
    #println(vs)
    #vnew = BloqadeKrylov.expm_multiply(2.55, to_matrix(Ht), state)

    #println(vnew)
    @test vold ≈ vs


end


#=
@testset "develop, please remove before pub" begin

    A = rand(10, 10)

    println( BloqadeKrylov.get_optimal_sm(1, A) )
    
end 
=#

module BloqadeKrylov

using Adapt
using BloqadeExpr
using LinearAlgebra
using Configurations
using YaoArrayRegister
using YaoSubspaceArrayReg
using BloqadeExpr: Hamiltonian, SumOfLinop
using ExponentialUtilities
using ProgressLogging
using GaussQuadrature

export emulate!, emulate_step!
export KrylovEvolution, Magnus4Evolution

export CFETEvolution
export CFET2_1, CFET4_2, CFET6_5, CFET8_11

# utils.jl introduce a new type of Hamiltonian called ValHamiltonian:
# BloqadeExpr.Hamiltonian 
#   |-> BloqadeExpr.StepHamiltonian
#         |-> BloqadeKrylov.ValHamiltonian (new)
#include("utils.jl")

## following are expm_multiply
export onenormest, expm_multiply!, expmv!
include("onenormest.jl")
include("expm_multiply.jl")
include("expmv.jl")

include("common.jl")
include("krylov.jl")
include("magnus.jl")

## following are CFET
include("cfet.jl")
include("tables/cfet_tbl.jl")



if VERSION < v"1.7"
    include("patch.jl")
end



end

using Test
using BloqadeKrylov

include("exact_sol_sinX.jl")


if "docstring" in ARGS
    # include("docstrings.jl")
    exit()
end



@testset "expm_multiply" begin
    include("expm_multiply.jl")
end


@testset "onenormest" begin
    include("onenormest.jl")
end

@testset "expmv" begin
    include("expmv.jl")
end

@testset "emulate" begin
    include("emulate.jl")
end


@testset "cfet42_sinX" begin
    include("cfet42_sinX.jl")
end


@testset "cfet65_sinX" begin
    include("cfet65_sinX.jl")
end

@testset "cfet811_sinX" begin
    include("cfet811_sinX.jl")
end


@testset "krylov_sinX" begin
    include("krylov_sinX.jl")
end

@testset "magnus4_sinX" begin
    include("magnus4_sinX.jl")
end


@testset "forwarddiff" begin
    include("forwarddiff.jl")
end

@testset "3-level supports" begin
    include("3-level_supports.jl")
end

using Bloqade
using BloqadeKrylov
using Plots



function H2_Square(T,Nt)
    nx, ny = 3, 3
    nsites = nx * ny
    atoms = generate_sites(SquareLattice(), nx, ny, scale = 6.7)
    
    Ω_max = 2π * 4.3
    Ω = piecewise_linear(clocks = [0.0/2.9, 0.3/2.9, 2.6/2.9, 1.0].*T, values = [0.0, Ω_max, Ω_max, 0]);

    U = 2π * 15.0
    Δ = piecewise_linear(clocks = [0.0/2.9, 0.3/2.9, 2.6/2.9, 1.0].*T, values = [-U, -U, U, U]);

    h = rydberg_h(atoms; Δ, Ω)
    atoms, h
end

function get_exact(T,testing_hamilt)
    NT = 10000
    atoms, h = testing_hamilt(T,NT)
    dt = T/NT
    clocks = collect(0:dt:T)
    odereg = zero_state(length(atoms))
    ODEprob = SchrodingerProblem(odereg,T,h)
    emulate!(ODEprob)
    return ODEprob
end

function krylov(T,NT,testing_hamilt)
    atoms, h = testing_hamilt(T,NT)
    dt = T/NT
    clocks = collect(0:dt:T)
    reg = zero_state(length(atoms))
    prob = KrylovEvolution(reg, clocks, h, tol=1.0e-12)
    emulate!(prob)
    return prob
end

function magnus42(T,NT,testing_hamilt)
    atoms, h = testing_hamilt(T,NT)
    dt = T/NT
    clocks = collect(0:dt:T)
    reg = zero_state(length(atoms))
    prob = CFETEvolution(reg, clocks, h, CFET4_2(),tol=1.0e-12)
    emulate!(prob)
    return prob
end

function magnus65(T,NT,testing_hamilt)
    atoms, h = testing_hamilt(T,NT)
    dt = T/NT
    clocks = collect(0:dt:T)
    reg = zero_state(length(atoms))
    prob = CFETEvolution(reg, clocks, h, CFET6_5(),tol=1.0e-12)
    emulate!(prob)
    return prob
end

function magnus811(T,NT,testing_hamilt)
    atoms, h = testing_hamilt(T,NT)
    dt = T/NT
    clocks = collect(0:dt:T)
    reg = zero_state(length(atoms))
    prob = CFETEvolution(reg, clocks, h, CFET8_11(),tol=1.0e-12)
    emulate!(prob)
    return prob
end

Ns = [2,4,8,16,32,64,128,256,512,1024,2048,4069,8192]
open("Ns","w") do f
    write(f,Ns)
end
Tfull = 2.9

# get exact
res_exact = get_exact(Tfull,H2_Square)


## magnus 42
es = Vector{Float64}(undef,0)
for n in Ns
    res = magnus42(Tfull,n,H2_Square)
    ## calculate differences:
    e = norm(res_exact.reg.state - res.reg.state)
    push!(es,e)
end
println(es)
open("es_m42","w") do f
    write(f,es)
end

## magnus 65
es = Vector{Float64}(undef,0)
for n in Ns
    res = magnus65(Tfull,n,H2_Square)
    ## calculate differences:
    e = norm(res_exact.reg.state - res.reg.state)
    push!(es,e)
end
println(es)
open("es_m65","w") do f
    write(f,es)
end

## krylov
es = Vector{Float64}(undef,0)
for n in Ns
    res = krylov(Tfull,n,H2_Square)
    ## calculate differences:
    e = norm(res_exact.reg.state - res.reg.state)
    push!(es,e)
end
println(es)
open("es_kry","w") do f
    write(f,es)
end



## magnus 811
es = Vector{Float64}(undef,0)
for n in Ns
    res = magnus811(Tfull,n,H2_Square)
    ## calculate differences:
    e = norm(res_exact.reg.state - res.reg.state)
    push!(es,e)
end
println(es)
open("es_m811","w") do f
    write(f,es)
end
